diff -purN u-boot/CHANGELOG u-boot-cfi_flash/CHANGELOG
--- u-boot/CHANGELOG	2005-08-18 16:56:44.000000000 +0900
+++ u-boot-cfi_flash/CHANGELOG	2005-08-19 13:01:02.535678081 +0900
@@ -2,6 +2,9 @@
 Changes for U-Boot 1.1.4:
 ======================================================================
 
+* Prohibit buffer write when buffer_size is 1 on drivers/cfi_flash.c
+  Patch by Sangmoon Kim, 19 Aug 2005
+
 * Add support for IFM o2dnt board
 
 * Enable PCI on hmi1001 board
diff -purN u-boot/drivers/cfi_flash.c u-boot-cfi_flash/drivers/cfi_flash.c
--- u-boot/drivers/cfi_flash.c	2005-08-18 16:57:25.000000000 +0900
+++ u-boot-cfi_flash/drivers/cfi_flash.c	2005-08-19 13:08:07.236719629 +0900
@@ -554,6 +554,17 @@ int write_buff (flash_info_t * info, uch
 	buffered_size = (info->portwidth / info->chipwidth);
 	buffered_size *= info->buffer_size;
 	while (cnt >= info->portwidth) {
+		if (info->buffer_size == 1) {
+			cword.l = 0;
+			for (i = 0; i < info->portwidth; i++) {
+				flash_add_byte (info, &cword, *src++);
+			}
+			if ((rc = flash_write_cfiword (info, wp, cword)) != 0)
+				return rc;
+			wp += info->portwidth;
+			cnt -= info->portwidth;
+			continue;
+		}
 		i = buffered_size > cnt ? cnt : buffered_size;
 		if ((rc = flash_write_cfibuffer (info, wp, src, i)) != ERR_OK)
 			return rc;

Signed-off-by: Sangmoon Kim <dogoil@etinsys.com>

